# Service account to run the af-connect-outbox.
apiVersion: v1
kind: ServiceAccount
metadata:
  name: af-connect-outbox
---
# Service to expose and loadbalance between pods.
apiVersion: v1
kind: Service
metadata:
  name: af-connect-outbox
spec:
  selector:
    app: af-connect-outbox
  ports:
    - protocol: TCP
      port: 8100
      targetPort: 8100
---
# Deployment to create necessary pods with configurations.
apiVersion: apps/v1
kind: Deployment
metadata:
  name: af-connect-outbox
  labels:
    app: af-connect-outbox
spec:
  replicas: 0
  selector:
    matchLabels:
      app: af-connect-outbox
  template:
    metadata:
      labels:
        app: af-connect-outbox
    spec:
      # Pod to launch the service.
      serviceAccountName: af-connect-outbox
      securityContext:
          # Your app shall always run as nonroot.
          runAsNonRoot: true
      affinity:
        # Avoid to run many pods on same physical node. It increases reliability.
        podAntiAffinity:
          preferredDuringSchedulingIgnoredDuringExecution:
          - weight: 1
            podAffinityTerm:
              labelSelector:
                matchLabels:
                  app: af-connect-outbox
              topologyKey: kubernetes.io/hostname
      volumes:
        - name: emptydir
          emptyDir: {}
      containers:
      - name: af-connect-outbox
        image: docker-images.jobtechdev.se/af-connect-outbox/af-connect-outbox:latest
        imagePullPolicy: Always
        ports:
        - containerPort: 8100
        readinessProbe:
          initialDelaySeconds: 5
          httpGet:
            path: /
            port: 8100
        livenessProbe:
          initialDelaySeconds: 5
          failureThreshold: 2
          httpGet:
            path: /
            port: 8100
        securityContext:
          # Your app shall always have the container file system read only. Use volumes for temp areas etc.
          readOnlyRootFilesystem: true
        resources:
          limits:
            memory: "512Mi"
          requests:
            memory: "512Mi"
        env:
          - name: REDIS_HOST
            value: redis-standalone
          - name: REDIS_PASSWORD
            valueFrom:
              secretKeyRef:
                name: redis-standalone
                key: database-password
        volumeMounts:
          - name: emptydir
            mountPath: /tmp
          - name:  emptydir
            mountPath: /.npm

          

